# Makefile for Apple MPW build environment (currently PPC only)

MAKEFILE     = Makefile
MondoBuild = #{MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
SDL_DIR = ":"
SymPPC      = 
ObjDirPPC   =
PPCC = 			MrCpp

CFLAGS  = -i "{SDL_DIR}:include:" -i "{SDL_DIR}:sgecollision:" {SymPPC}

OBJS  = 
  "{ObjDirPPC}sge_collision.cpp.x" 
  "{ObjDirPPC}sge_misc.cpp.x" 
  "{ObjDirPPC}Main.cpp.x" 
		"{ObjDirPPC}FeeManager.cpp.x" 
		"{ObjDirPPC}FeeSprite.cpp.x" 
		"{ObjDirPPC}PlayerSprite.cpp.x" 
		"{ObjDirPPC}FeeHelper.cpp.x" 
		"{ObjDirPPC}ShotSprite.cpp.x" 
		"{ObjDirPPC}MovingSprite.cpp.x" 
 	"{ObjDirPPC}SmokeSprite.cpp.x" 
  "{ObjDirPPC}FeeList.cpp.x" 
  "{ObjDirPPC}WoodstockSprite.cpp.x" 
  "{ObjDirPPC}CloudSprite.cpp.x" 
  "{ObjDirPPC}FeeSound.cpp.x" 
  "{ObjDirPPC}ExplosionSprite.cpp.x" 
  "{ObjDirPPC}StatusSprite.cpp.x" 
  "{ObjDirPPC}PumpkinSprite.cpp.x" 
  "{ObjDirPPC}SnoopyGlobals.cpp.x" 
  "{ObjDirPPC}Console.cpp.x" 
  "{ObjDirPPC}CON_console.c.x" 
  "{ObjDirPPC}CON_consolecommands.c.x" 
  "{ObjDirPPC}DT_drawtext.c.x" 
  "{ObjDirPPC}BounderSprite.cpp.x"
  
  

LIBS = 	
		"{SDL_DIR}:lib:SDLmain.o" "{SDL_DIR}:lib:SDL"

# This is used to build the application
Snoopy  {MondoBuild} {OBJS}
	PPCLink 
		-o "{Targ}" {SymPPC} 
		{OBJS} {LIBS} 
		"{SharedLibraries}InterfaceLib" 
		"{SharedLibraries}QuickTimeLib" 
		"{SharedLibraries}StdCLib" 
		"{SharedLibraries}MathLib" 
		"{PPCLibraries}StdCRuntime.o" 
		"{PPCLibraries}PPCCRuntime.o" 
		"{PPCLibraries}PPCToolLibs.o"
		"{SDL_DIR}:lib:SDL_Image.o" 
		"{SDL_DIR}:lib:SDL_Mixer.o" 
		"{PPCLibraries}"MrCPlusLib.o
	Rez -a -o {Targ} "{SDL_DIR}:rsrc:SDL.r"
	Rez -a -o {Targ} "{SDL_DIR}:rsrc:SIZE.r"

"{ObjDirPPC}sge_collision.cpp.x"  {MondoBuild} "sge_collision.cpp"
	{PPCC} "sge_collision.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}sge_misc.cpp.x"  {MondoBuild} "sge_misc.cpp"
	{PPCC} "sge_misc.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}main.cpp.x"  {MondoBuild} "main.cpp"
	{PPCC} "main.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}FeeManager.cpp.x"  {MondoBuild} "FeeManager.cpp"
	{PPCC} "FeeManager.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}FeeSprite.cpp.x"  {MondoBuild} "FeeSprite.cpp"
	{PPCC} "FeeSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}PlayerSprite.cpp.x"  {MondoBuild} "PlayerSprite.cpp"
	{PPCC} "PlayerSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}FeeHelper.cpp.x"  {MondoBuild} "FeeHelper.cpp"
	{PPCC} "FeeHelper.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}ShotSprite.cpp.x"  {MondoBuild} "ShotSprite.cpp"
	{PPCC} "ShotSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}MovingSprite.cpp.x"  {MondoBuild} "MovingSprite.cpp"
	{PPCC} "MovingSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}SmokeSprite.cpp.x"  {MondoBuild} "SmokeSprite.cpp"
	{PPCC} "SmokeSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}FeeList.cpp.x"  {MondoBuild} "FeeList.cpp"
	{PPCC} "FeeList.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}WoodstockSprite.cpp.x"  {MondoBuild} "WoodstockSprite.cpp"
	{PPCC} "WoodstockSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}CloudSprite.cpp.x"  {MondoBuild} "CloudSprite.cpp"
	{PPCC} "CloudSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}FeeSound.cpp.x"  {MondoBuild} "FeeSound.cpp"
	{PPCC} "FeeSound.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}ExplosionSprite.cpp.x"  {MondoBuild} "ExplosionSprite.cpp"
	{PPCC} "ExplosionSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}StatusSprite.cpp.x"  {MondoBuild} "StatusSprite.cpp"
	{PPCC} "StatusSprite.cpp" -o {Targ} {CFLAGS}
"{ObjDirPPC}BounderSprite.cpp.x"  {MondoBuild} "BounderSprite.cpp"
	{PPCC} "BounderSprite.cpp" -o {Targ} {CFLAGS}  
"{ObjDirPPC}PumpkinSprite.cpp.x"  {MondoBuild} "PumpkinSprite.cpp"
	{PPCC} "PumpkinSprite.cpp" -o {Targ} {CFLAGS}  
"{ObjDirPPC}CON_console.c.x"  {MondoBuild} "CON_console.c"
	{PPCC} "CON_console.c" -o {Targ} {CFLAGS}  
"{ObjDirPPC}CON_consolecommands.c.x"  {MondoBuild} "CON_consolecommands.c"
	{PPCC} "CON_consolecommands.c" -o {Targ} {CFLAGS}  
"{ObjDirPPC}DT_drawtext.c.x"  {MondoBuild} "DT_drawtext.c"
	{PPCC} "DT_drawtext.c" -o {Targ} {CFLAGS}  
"{ObjDirPPC}Console.cpp.x"  {MondoBuild} "Console.cpp"
	{PPCC} "Console.cpp" -o {Targ} {CFLAGS}  
"{ObjDirPPC}SnoopyGlobals.cpp.x"  {MondoBuild} "SnoopyGlobals.cpp"
	{PPCC} "SnoopyGlobals.cpp" -o {Targ} {CFLAGS}  
