// AIPlayerSprite.cpp: implementation of the AIPlayerSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "FeeGlobal.h"
#include "PlayerSprite.h"
#include "AIPlayerSprite.h"
#include "FeeManager.h"
#include "GameOptions.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AIPlayerSprite::AIPlayerSprite(int x, int y, int kind, FeeManager *derManager):PlayerSprite(x, y, kind, derManager)
{
	active = false;
}

AIPlayerSprite::~AIPlayerSprite()
{

}

void AIPlayerSprite::Activate()
{
    active = !active;
	myManager->options->useAI=active;
}

bool AIPlayerSprite::IsActive()
{
	return active;
}

bool AIPlayerSprite::IsAI()
{
	if (active)
		return true;
	else
		return false;

}

bool AIPlayerSprite::ShowAmmo()
{
	if (myManager->options->showAmmoBoard==AMMO_BOARD_ALL)
		return true;
	if (!active)
		if (myManager->options->showAmmoBoard==AMMO_BOARD_NO_AI)
			return true;
	
	return false;
}
