// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// BounderSprite.cpp: implementation of the BounderSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "FeeSprite.h"
#include "BounderSprite.h"
#include "SnoopyGlobals.h"
#include "SDL.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BounderSprite::BounderSprite(SDL_Rect bounder,int myKind, FeeManager* myManager):FeeSprite(bounder.x,bounder.y,myManager)
{
	this->myKind=myKind;
	this->bounder=bounder;
	//collisionMask=sge_make_solid_cmap(bounder);
	//face = !(NULL);
	if (myKind==GROUND_KIND)
		name="Ground";
	else
		name="Sky";
}

BounderSprite::~BounderSprite()
{
	face=NULL;
}

void BounderSprite::Update(float time)
{
}

void BounderSprite::Hit(FeeSprite *hitBy)
{
}

SDL_Rect BounderSprite::GetRect()
{
	return bounder;
}

int BounderSprite::CollidesWith(FeeSprite *theSprite)
{
	if (!theSprite->canCollide) return false;
	if (myKind==GROUND_KIND)
	{
		if ((theSprite->myKind==ARROW_KIND)||(theSprite->myKind==HM_KIND)||(theSprite->myKind==MG_KIND)||(theSprite->myKind==BOMB_KIND)||(theSprite->myKind==BASEBALL_KIND)||(theSprite->myKind==FLYING_PART_KIND))
		{
			if (theSprite->y >= bounder.y+18)
				return true;
			else 
				return false;
		}
		if (theSprite->y >= bounder.y)
			return true;
		else 
			return false;
	}
	else if (myKind==SKY_KIND)
	{
		if (theSprite->y < (bounder.y+bounder.h))
			return true;
		else 
			return false;
	}
	return false;
}
