// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// CloudSprite.cpp: implementation of the CloudSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "FeeManager.h"
#include "MovingSprite.h"
#include "CloudSprite.h"
#include "sge_misc.h"
#include "SnoopyGlobals.h"
#include "SDL.h"
#include <stdlib.h>
#include "FeeImageManager.h"
#include "GameOptions.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CloudSprite::CloudSprite(FeeManager *theManager):MovingSprite(0,0,theManager,true)
{
	char filename[_MAX_PATH];
	name=(char*)malloc(10); // Platz schaffen fr den Namen

	num=sge_Random(1,3);
	sprintf(name,"Cloud %i",num);

	
	sprintf(filename,myManager->options->GetDataPath("Grafiken/Cloud%i.jpg"),num);
	face=myManager->imageManager->GetAlphaSurface((char*)&filename);
	//InitFaceFromIMG(filename);

	canCollide=false;
	this->speed=1;
	//angle=sge_Random(0,16)*25;
	this->x=sge_Random(0,myManager->maxX);
	this->y=sge_Random(0,myManager->maxY);

	myKind=CLOUD_KIND;

	ComputeSpeed();
	//SDL_SetAlpha(face,SDL_RLEACCEL|SDL_SOURCEALPHA,224);
}

CloudSprite::~CloudSprite()
{
	free(name);
}

void CloudSprite::Update(float time)
{
	int i=sge_Random(0,10);

	if(i==0)
	{
		if (speedY==0)
			speedY=1;
		else
			speedY=0;
	}
	else if(i==1)
	{
		if (speedY==0)
			speedY=-1;			
		else
			speedY=0;
	}

	MovingSprite::Update(time);

	if (face)
	{
		if (x > myManager->maxX) x += -face->w -myManager->maxX; // an der Seite rausgeflogenen Wolke
		else if (x < (-face->w)) x = myManager->maxX +face->w + x;    // auf die andere Seite bringen
		if (y > (myManager->maxY)) y += -face->h -myManager->maxY;  // an der Decke rausgeflogenen Wolke
		else if (y < (-face->h)) y = myManager->maxY +face->h + y; // auf den Boden bringen	
	}

	/*
	if (y>(myManager->maxY-BODEN)) 
	{
		y=(myManager->maxY-BODEN);
		angle-=200;
	}

	if (y < 0) 
	{
		y=0;
		angle-=200;
	}*/

	angle%=400;
}

void CloudSprite::Hit(FeeSprite *hitBy)
{

}

