// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// ExplosionSprite.cpp: implementation of the ExplosionSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "SmokeSprite.h"
#include "ExplosionSprite.h"
#include "SnoopyGlobals.h"
#include "FeeHelper.h"
#include "FeeManager.h"
#include "FeeImageManager.h"
#include "FeeSound.h"
#include "GameOptions.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ExplosionSprite::ExplosionSprite(int x, int y, FeeManager *derManager):SmokeSprite(x,y, derManager, true)
{
	// hier sollten x und y ge-=t werden mit (face->w/2) und (face->h/2)
	// um die Explosion an genau den Koordinaten zu starten.
	name="Explosion";
	myKind=EXPLO_KIND;
	canCollide=true;
	theExplosionSound->Play();
}

ExplosionSprite::~ExplosionSprite()
{
}

void ExplosionSprite::Update(float time)
{
	if (DoAction(time))
	{
		age++;
		if (!face)
		{
			face=myManager->imageManager->GetImage(myManager->options->GetDataPath("Grafiken/Explo.tga"));
			collisionMask=myManager->imageManager->GetMask(myManager->options->GetDataPath("Grafiken/Explo.tga"));
			x=x-(face->w/2);
			y=y-(face->h/2);
		}

		if (myManager->options->useGL)
		{
			if (age > 12) alpha-=28;
			if (age > 21) toBeRemoved=true;
		}
		else
			if (age > 15) toBeRemoved=true;

		if (age > 3) canCollide=false;
	}
}

