// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

#include "SDL.h"
#include "FeeGlobal.h"
#include "FeeHelper.h"

void ClipRect(SDL_Rect *rect, SDL_Rect *clip)
{
	if (rect->x<clip->x) rect->x=clip->x;
	if (rect->y<clip->y) rect->y=clip->y;
	if (rect->w>clip->w) rect->w=clip->w;
	if (rect->h>clip->h) rect->h=clip->h;
}

SDL_Rect GetSurfaceRect(SDL_Surface *face)
{
	SDL_Rect rect={0,0,face->w,face->h};	
	return rect;
}

void ConvertToDisplaySurface(SDL_Surface **face, bool alpha)
{
	SDL_Surface *temp;

	if (!alpha)
		temp=SDL_DisplayFormat(*face);
	else
		temp=SDL_DisplayFormatAlpha(*face);

	if (temp==NULL)
		*face=temp;
	else
	{
		SDL_FreeSurface(*face);
		*face=temp;
	}

}
