// FeeImageList.h: interface for the FeeImageList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FEEIMAGELIST_H__5AE19DF1_56F0_4780_931E_0005DCDAE073__INCLUDED_)
#define AFX_FEEIMAGELIST_H__5AE19DF1_56F0_4780_931E_0005DCDAE073__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FeeGlobal.h"
#include "sge_collision.h"
#ifdef HAVE_GL_H
#ifdef MACOSX
#include <OpenGL/gl.h>
#else
#include "GL/gl.h"
#endif
#include "GLDynamicLoad.h"
#endif

#ifndef NO_VOODOO_FIX
extern "C" int SDL_SoftStretch(SDL_Surface *src, SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect);
#endif


#define IMAGE_SIMPLE 1
#define IMAGE_CONVERT_ALPHA 2

#ifdef HAVE_GL_H
int SafeSize(int i);
GLuint FaceToTexture(SDL_Surface *face);
#endif

class FeeImageList
{
public:
	FeeImageList(SDL_Surface *face, char *name);
	virtual ~FeeImageList();
	FeeImageList *next;
	SDL_Surface *GetImage();
#ifdef HAVE_GL_H
	GLuint GetTexture();
	void UpdateTexture();
#endif
	sge_cdata *GetMask();
	bool IsImage(char *filename);
	char name[_MAX_PATH];
protected:
	SDL_Surface *myImage;
#ifdef HAVE_GL_H
	GLuint myTex;
#endif
	sge_cdata *myMask;
};

#endif // !defined(AFX_FEEIMAGELIST_H__5AE19DF1_56F0_4780_931E_0005DCDAE073__INCLUDED_)
