// FeeManager.h: interface for the FeeManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FEEMANAGER_H__81209B79_77BD_426B_B3C6_E04248DEF5FE__INCLUDED_)
#define AFX_FEEMANAGER_H__81209B79_77BD_426B_B3C6_E04248DEF5FE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FeeGlobal.h"
#include "FeeList.h"
#include "SDL.h"

class GameOptions;
class FeeImageManager;

class FeeManager
{
public:
	SDL_Surface *InitializeScreen(int w, int h);
	SDL_Surface * GetBkgnd();
	int GetLOD();
	void SetLOD(int i);
	FeeManager();

	virtual ~FeeManager();

	FeeList *spriteList;

	virtual void Update(float time);
	void AddSprite(FeeSprite *theSprite);
	void AddSpriteInFront(FeeSprite *theSprite);
	void RemoveSprite(FeeSprite *theSprite);
	void MoveSpriteToTop(FeeSprite *theSprite);
	void InitializeSoundSystem();
	void NewBkgnd(char *filename);
	void NewTransparentBkgnd(char *filename);
	void Flip();
	int maxX;
	int maxY;
	long frame;

	virtual void Log(char *toLog);

	virtual FeeSprite *GetSprite(int theKind);		// Sprite Suchfunktionen
	virtual FeeSprite *GetNextSprite(int theKind);
	bool SpriteExists(FeeSprite *sprite);
	FeeList *lastList;

	FeeImageManager *imageManager;

	GameOptions *options;

	long spriteCount;

	Uint8 *keystate;
	bool keystateValid;
protected:

	char *bkgndName;
	SDL_Surface *targetSurface;
	SDL_Surface *bkgndSurface;
	int soundSystemInitialized;
};

#endif // !defined(AFX_FEEMANAGER_H__81209B79_77BD_426B_B3C6_E04248DEF5FE__INCLUDED_)
