// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

#include "FeeSound.h"

// Zuerst der Mac-Teil mit Quicktime-Routinen:

#ifdef macintosh
#include "QuicktimeComponents.h"
#include "Files.h"
#include "Sound.h"
#include "TextUtils.h"
#include "Processes.h"
#include "string.h"
void MacPfad(char *&pfad); // Die Warnung nervt sonst.

void MacPfad(char *&pfad)	// ByRef-bergabe eines Zeigers
{ 
#ifdef USE_SOUND
	char *neuerPfad;
	char *durchgehen;
  	neuerPfad = (char *)malloc(strlen(pfad)+2);
	if ( *pfad != ':' )
		sprintf(neuerPfad, ":%s", pfad);
	else
		sprintf(neuerPfad, "%s", pfad); 
	durchgehen = neuerPfad;
	// ".." ist am Mac "::"
  	while ( (durchgehen=strstr(durchgehen, "../")) != NULL ) 
	{
		*durchgehen++ = ':';
		strcpy (durchgehen, durchgehen+2);
  	}
	// Jetzt noch alle "/" durch ":" ersetzen:
  	for ( durchgehen = neuerPfad; *durchgehen; ++durchgehen ) 
	{
		if ( *durchgehen == '/' )
			*durchgehen = ':';
  	}
	// Fertig. Hoffentlich geht das
	pfad = neuerPfad;
#endif
}

FeeSound::FeeSound(char *path)
{
#ifdef USE_SOUND
	short myRefNum;
	FSSpec theFile;	
	
	// Erstmal das aktuelle Verzeichnis finden:
	ProcessInfoRec appInfo;
	appInfo.processName = NULL;
	appInfo.processInfoLength = sizeof(ProcessInfoRec); // Fuer alte Systeme
	appInfo.processAppSpec = &theFile;
	ProcessSerialNumber dieProzessNummer;
	GetCurrentProcess(&dieProzessNummer);
	GetProcessInformation(&dieProzessNummer, &appInfo);
	
	// Jetzt den gegebenen Pfad in einen MacPfad verwandeln:
	MacPfad(path);
	Str255 pfadname;
	CopyCStringToPascal(path, pfadname);
	if (FSMakeFSSpec (theFile.vRefNum, theFile.parID, pfadname, &theFile) != noErr)
	{
		theSound = NULL;
		return;
	}
	// Und ein Quicktime-Movie erstellen:
	OpenMovieFile(&theFile, &myRefNum, fsRdPerm);
	NewMovieFromFile(&theSound, myRefNum, NULL, (StringPtr)NULL, newMovieActive, NULL);
	if (myRefNum != 0)
		CloseMovieFile(myRefNum); // Datei wieder schlieen
	// Fertig!
#endif
}

FeeSound::~FeeSound()
{
#ifdef USE_SOUND
	// Movie lschen
	if (theSound) DisposeMovie(theSound);
#endif
}

void FeeSound::Play()
{
#ifdef USE_SOUND
	if (theSound) 
	{
		StopMovie(theSound);
		GoToBeginningOfMovie(theSound);
		StartMovie(theSound);
	}
#endif
}
#else // PC-Definitionen mit SDL_mixer

FeeSound::FeeSound(char *path)
{
#ifdef USE_SOUND
	theSound = Mix_LoadWAV(path);
#endif
}

FeeSound::~FeeSound()
{
#ifdef USE_SOUND
	if (theSound) Mix_FreeChunk(theSound);
#endif
}

void FeeSound::Play()
{
#ifdef USE_SOUND
	if (theSound) Mix_PlayChannel(-1, theSound, 0);
#endif
}

#endif