// FeeSprite.h: interface for the FeeSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FEESPRITE_H__21410289_C50A_4EFD_8F43_6FF8CCCC08D5__INCLUDED_)
#define AFX_FEESPRITE_H__21410289_C50A_4EFD_8F43_6FF8CCCC08D5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FeeGlobal.h"
#include "sge_collision.h"
#ifdef HAVE_GL_H
#ifdef MACOSX
#include <OpenGL/gl.h>
#else
#include <GL/gl.h>
#endif
#endif
class FeeManager;

#include "SDL.h"

class FeeSprite
{
public:
	bool canCollide;
	char *name;
	virtual int CollidesWith(FeeSprite *theSprite);
	bool toBeRemoved;
	virtual SDL_Rect GetRect(void);
	virtual void Hit(FeeSprite *hitBy)=0;
	virtual void Update(float time)=0;
	virtual void DrawTo(SDL_Surface *target);
	float y;
	float x;
	int frame;
	FeeSprite(int x, int y, FeeManager *derManager, bool inFront = true);
	virtual ~FeeSprite();
	int myKind;
	SDL_Surface *face;

	float updateCount;
protected:
	bool DoAction(float time);
	FeeManager *myManager;
	sge_cdata *collisionMask;
	void InitFaceFromIMG(char *path);
	int alpha;
};

#endif // !defined(AFX_FEESPRITE_H__21410289_C50A_4EFD_8F43_6FF8CCCC08D5__INCLUDED_)
