// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

#include "SnoopyGlobals.h"
#include "FeeGlobal.h"
#include "FlyingPartSprite.h"
#include "ShotSprite.h"
#include "FeeManager.h"
#include "FeeSound.h"
#include "FeeImageManager.h"
#include "sge_misc.h"
#include <math.h>
#include "CON_console.h"

FlyingPartSprite::FlyingPartSprite(int x, int y, FeeManager *derManager):MovingSprite(x,y, derManager)
{
	myKind=FLYING_PART_KIND;
	name="Flying parts";
	face = NULL;
	frame = 0;
	speedX = 0;
	speedY = 0;
	zaehler=0;
}

FlyingPartSprite::~FlyingPartSprite()
{
}

void FlyingPartSprite::Update(float time)
{	
	if (DoAction(time))
		if ((zaehler++) % 2) speedY++;
	MovingSprite::Update(time);

	if (y > myManager->maxY) toBeRemoved = true; //Sicher ist sicher
	if (x > myManager->maxX) x += -29 -myManager->maxX; // an der Seite rausgeflogenen Schrott
	else if (x < (-29)) x = myManager->maxX +29 + x;    // auf die andere Seite bringen
}

void FlyingPartSprite::Hit(FeeSprite *hitBy)
{
	if ((hitBy->myKind != SKY_KIND) && (hitBy->myKind != GROUND_KIND) && (hitBy->myKind != FLYING_PART_KIND)&&(hitBy->myKind != SCHROEDER_KIND)&&(hitBy->myKind != EXPLO_KIND)) 
		toBeRemoved = true;
	else
		if ((hitBy->myKind == GROUND_KIND) && (speedY > -5))
		{
			speedY = speedY*(-0.8);
			if (speedY > -5) toBeRemoved = true; // Zu wenig Schwung, unauffllig auflsen
		}
}

void FlyingPartSprite::SpawnFlyingParts(int x, int y, char *filename, int anzahlTeile, FeeManager *derManager, int initialSpeed)
{
	derManager->imageManager->PrecacheFrames(filename,anzahlTeile);
	double angle = (400.0 / anzahlTeile) + 1; // so vermeiden wir 100-Grad Winkel
	double winkel;
	int speedX, speedY;
	FlyingPartSprite *dasSprite;
	for (int i = 0; i < anzahlTeile; i++)
	{
		winkel=double(i*angle)/200*PI;
		speedX=cos(winkel)*initialSpeed;
		speedY=sin(winkel)*initialSpeed;
		dasSprite = new FlyingPartSprite(x+speedX*2, y+speedY*2, derManager);
		dasSprite->face = derManager->imageManager->GetFrame(filename,i);		
		dasSprite->collisionMask = derManager->imageManager->GetFrameMask(filename,i);		
		dasSprite->speedX = speedX;
		dasSprite->speedY = speedY;
	}
}

