#ifdef HAVE_GL_H

#ifndef GL_LINK_STATICALLY

#include "FeeGlobal.h"
#include "GL/gl.h"

#ifdef WIN32
#define STDCALL __stdcall
#else
#define STDCALL
#endif

typedef void (STDCALL *glGenTextures_Func) (GLsizei n, GLuint *textures);
typedef void (STDCALL *glBindTexture_Func) (GLenum target, GLuint texture);
typedef void (STDCALL *glPixelStorei_Func) (GLenum pname, GLint param);
typedef void (STDCALL *glTexImage2D_Func) (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
typedef void (STDCALL *glTexEnvi_Func) (GLenum target, GLenum pname, GLint param);
typedef void (STDCALL *glTexParameteri_Func) (GLenum target, GLenum pname, GLint param);
typedef void (STDCALL *glTexParameterf_Func) (GLenum target, GLenum pname, GLfloat param);
typedef void (STDCALL *glDeleteTextures_Func) (GLsizei n, const GLuint *textures);
typedef void (STDCALL *glColor4ub_Func) (GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
typedef void (STDCALL *glBegin_Func) (GLenum mode);
typedef void (STDCALL *glEnd_Func) (void);
typedef void (STDCALL *glTexCoord2f_Func) (GLfloat s, GLfloat t);
typedef void (STDCALL *glVertex3f_Func) (GLfloat x, GLfloat y, GLfloat z);
typedef void (STDCALL *glVertex3i_Func) (GLint x, GLint y, GLint z);
typedef void (STDCALL *glTranslatef_Func) (GLfloat x, GLfloat y, GLfloat z);

typedef void (STDCALL *glOrtho_Func) (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
typedef void (STDCALL *glClear_Func) (GLbitfield mask);
typedef void (STDCALL *glEnable_Func) (GLenum cap);
typedef void (STDCALL *glDisable_Func) (GLenum cap);
typedef void (STDCALL *glHint_Func) (GLenum target, GLenum mode);
typedef void (STDCALL *glMatrixMode_Func) (GLenum mode);
typedef void (STDCALL *glBlendFunc_Func) (GLenum sfactor, GLenum dfactor);
typedef void (STDCALL *glShadeModel_Func) (GLenum mode);
typedef void (STDCALL *glLoadIdentity_Func) (void);
typedef void (STDCALL *glClearColor_Func) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
typedef void (STDCALL *glClearDepth_Func) (GLclampd depth);



glGenTextures_Func glGenTextures_priv=0;
glBindTexture_Func glBindTexture_priv=0;
glPixelStorei_Func glPixelStorei_priv=0;
glTexImage2D_Func glTexImage2D_priv=0;
glTexEnvi_Func glTexEnvi_priv=0;
glTexParameteri_Func glTexParameteri_priv=0;
glTexParameterf_Func glTexParameterf_priv=0;
glDeleteTextures_Func glDeleteTextures_priv=0;
glColor4ub_Func glColor4ub_priv=0;
glBegin_Func glBegin_priv=0;
glEnd_Func glEnd_priv=0;
glTexCoord2f_Func glTexCoord2f_priv=0;
glVertex3f_Func glVertex3f_priv=0;
glVertex3i_Func glVertex3i_priv=0;
glTranslatef_Func glTranslatef_priv=0;

glOrtho_Func glOrtho_priv=0;
glClear_Func glClear_priv=0;
glEnable_Func glEnable_priv=0;
glDisable_Func glDisable_priv=0;
glHint_Func glHint_priv=0;
glMatrixMode_Func glMatrixMode_priv=0;
glBlendFunc_Func glBlendFunc_priv=0;
glShadeModel_Func glShadeModel_priv=0;
glLoadIdentity_Func glLoadIdentity_priv=0;
glClearColor_Func glClearColor_priv=0;
glClearDepth_Func glClearDepth_priv=0;

#include "SDL.h"

bool LoadGLFunctions()
{
	if (SDL_GL_LoadLibrary(NULL))
		return false;

	glGenTextures_priv = (glGenTextures_Func)SDL_GL_GetProcAddress("glGenTextures");
	glBindTexture_priv = (glBindTexture_Func)SDL_GL_GetProcAddress("glBindTexture");
	glPixelStorei_priv = (glPixelStorei_Func)SDL_GL_GetProcAddress("glPixelStorei");
	glTexImage2D_priv = (glTexImage2D_Func)SDL_GL_GetProcAddress("glTexImage2D");
	glTexEnvi_priv = (glTexEnvi_Func)SDL_GL_GetProcAddress("glTexEnvi");
	glTexParameteri_priv = (glTexParameteri_Func)SDL_GL_GetProcAddress("glTexParameteri");
	glTexParameterf_priv = (glTexParameterf_Func)SDL_GL_GetProcAddress("glTexParameterf");
	glDeleteTextures_priv = (glDeleteTextures_Func)SDL_GL_GetProcAddress("glDeleteTextures");
	glColor4ub_priv = (glColor4ub_Func)SDL_GL_GetProcAddress("glColor4ub");
	glBegin_priv = (glBegin_Func)SDL_GL_GetProcAddress("glBegin");
	glEnd_priv = (glEnd_Func)SDL_GL_GetProcAddress("glEnd");
	glTexCoord2f_priv = (glTexCoord2f_Func)SDL_GL_GetProcAddress("glTexCoord2f");
	glVertex3f_priv = (glVertex3f_Func)SDL_GL_GetProcAddress("glVertex3f");
	glVertex3i_priv = (glVertex3i_Func)SDL_GL_GetProcAddress("glVertex3i");
	glTranslatef_priv = (glTranslatef_Func)SDL_GL_GetProcAddress("glTranslatef");

	glOrtho_priv = (glOrtho_Func)SDL_GL_GetProcAddress("glOrtho");
	glClear_priv = (glClear_Func)SDL_GL_GetProcAddress("glClear");
	glEnable_priv = (glEnable_Func)SDL_GL_GetProcAddress("glEnable");
	glDisable_priv = (glDisable_Func)SDL_GL_GetProcAddress("glDisable");
	glHint_priv = (glHint_Func)SDL_GL_GetProcAddress("glHint");
	glMatrixMode_priv = (glMatrixMode_Func)SDL_GL_GetProcAddress("glMatrixMode");
	glBlendFunc_priv = (glBlendFunc_Func)SDL_GL_GetProcAddress("glBlendFunc");
	glShadeModel_priv = (glShadeModel_Func)SDL_GL_GetProcAddress("glShadeModel");
	glLoadIdentity_priv = (glLoadIdentity_Func)SDL_GL_GetProcAddress("glLoadIdentity");
	glClearColor_priv = (glClearColor_Func)SDL_GL_GetProcAddress("glClearColor");
	glClearDepth_priv = (glClearDepth_Func)SDL_GL_GetProcAddress("glClearDepth");

	if (!glGenTextures_priv)
		return false;
	return true;
}

#endif // GL_LINK_STATICALLY

#endif // HAVE_GL_H