#ifndef GL_DYNAMIC_LOAD
#define GL_DYNAMIC_LOAD

#ifdef HAVE_GL_H

#include "GL/gl.h"

#ifndef GL_LINK_STATICALLY

#ifdef WIN32
#define STDCALL __stdcall
#else
#define STDCALL
#endif

typedef void (STDCALL *glGenTextures_Func) (GLsizei n, GLuint *textures);
typedef void (STDCALL *glBindTexture_Func) (GLenum target, GLuint texture);
typedef void (STDCALL *glPixelStorei_Func) (GLenum pname, GLint param);
typedef void (STDCALL *glTexImage2D_Func) (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
typedef void (STDCALL *glTexEnvi_Func) (GLenum target, GLenum pname, GLint param);
typedef void (STDCALL *glTexParameteri_Func) (GLenum target, GLenum pname, GLint param);
typedef void (STDCALL *glTexParameterf_Func) (GLenum target, GLenum pname, GLfloat param);
typedef void (STDCALL *glDeleteTextures_Func) (GLsizei n, const GLuint *textures);
typedef void (STDCALL *glColor4ub_Func) (GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
typedef void (STDCALL *glBegin_Func) (GLenum mode);
typedef void (STDCALL *glEnd_Func) (void);
typedef void (STDCALL *glTexCoord2f_Func) (GLfloat s, GLfloat t);
typedef void (STDCALL *glVertex3f_Func) (GLfloat x, GLfloat y, GLfloat z);
typedef void (STDCALL *glVertex3i_Func) (GLint x, GLint y, GLint z);
typedef void (STDCALL *glTranslatef_Func) (GLfloat x, GLfloat y, GLfloat z);

typedef void (STDCALL *glOrtho_Func) (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
typedef void (STDCALL *glClear_Func) (GLbitfield mask);
typedef void (STDCALL *glEnable_Func) (GLenum cap);
typedef void (STDCALL *glDisable_Func) (GLenum cap);
typedef void (STDCALL *glHint_Func) (GLenum target, GLenum mode);
typedef void (STDCALL *glMatrixMode_Func) (GLenum mode);
typedef void (STDCALL *glBlendFunc_Func) (GLenum sfactor, GLenum dfactor);
typedef void (STDCALL *glShadeModel_Func) (GLenum mode);
typedef void (STDCALL *glLoadIdentity_Func) (void);
typedef void (STDCALL *glClearColor_Func) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
typedef void (STDCALL *glClearDepth_Func) (GLclampd depth);


extern glGenTextures_Func glGenTextures_priv;
extern glBindTexture_Func glBindTexture_priv;
extern glPixelStorei_Func glPixelStorei_priv;
extern glTexImage2D_Func glTexImage2D_priv;
extern glTexEnvi_Func glTexEnvi_priv;
extern glTexParameteri_Func glTexParameteri_priv;
extern glTexParameterf_Func glTexParameterf_priv;
extern glDeleteTextures_Func glDeleteTextures_priv;
extern glColor4ub_Func glColor4ub_priv;
extern glBegin_Func glBegin_priv;
extern glEnd_Func glEnd_priv;
extern glTexCoord2f_Func glTexCoord2f_priv;
extern glVertex3f_Func glVertex3f_priv;
extern glVertex3i_Func glVertex3i_priv;
extern glTranslatef_Func glTranslatef_priv;

extern glOrtho_Func glOrtho_priv;
extern glClear_Func glClear_priv;
extern glEnable_Func glEnable_priv;
extern glDisable_Func glDisable_priv;
extern glHint_Func glHint_priv;
extern glMatrixMode_Func glMatrixMode_priv;
extern glBlendFunc_Func glBlendFunc_priv;
extern glShadeModel_Func glShadeModel_priv;
extern glLoadIdentity_Func glLoadIdentity_priv;
extern glClearColor_Func glClearColor_priv;
extern glClearDepth_Func glClearDepth_priv;

extern bool LoadGLFunctions();

#else // GL_LINK_STATICALLY

#define glGenTextures_priv glGenTextures
#define glBindTexture_priv glBindTexture
#define glPixelStorei_priv glPixelStorei
#define glTexImage2D_priv glTexImage2D
#define glTexEnvi_priv glTexEnvi
#define glTexParameteri_priv glTexParameteri
#define glTexParameterf_priv glTexParameterf
#define glDeleteTextures_priv glDeleteTextures
#define glColor4ub_priv glColor4ub
#define glBegin_priv glBegin
#define glEnd_priv glEnd
#define glTexCoord2f_priv glTexCoord2f
#define glVertex3f_priv glVertex3f
#define glVertex3i_priv glVertex3i
#define glTranslatef_priv glTranslatef
#define glOrtho_priv glOrtho
#define glClear_priv glClear
#define glEnable_priv glEnable
#define glDisable_priv glDisable
#define glHint_priv glHint
#define glMatrixMode_priv glMatrixMode
#define glBlendFunc_priv glBlendFunc
#define glShadeModel_priv glShadeModel
#define glLoadIdentity_priv glLoadIdentity
#define glClearColor_priv glClearColor
#define glClearDepth_priv glClearDepth

#define LoadGLFunctions() true

#endif // GL_LINK_STATICALLY

#endif // HAVE_GL_H


#endif // GL_DYNAMIC_LOAD