// GameOptions.h: interface for the GameOptions class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEOPTIONS_H__29F9945A_AE8B_4417_A348_052A6F578A4A__INCLUDED_)
#define AFX_GAMEOPTIONS_H__29F9945A_AE8B_4417_A348_052A6F578A4A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class FeeManager;

#define HIT_SETTINGS_GETS_WORSE 0
#define HIT_SETTINGS_STAYS 1
#define HIT_SETTINGS_NO_CONTROL 2

#define AMMO_BOARD_NONE 0
#define AMMO_BOARD_ALL 1
#define AMMO_BOARD_NO_AI 2

class GameOptions
{
public:
	char * GetDataPath(char *filename);
	int LoadOptions();
	void OptionsChanged();
	GameOptions(FeeManager *theManager);
	virtual ~GameOptions();
	bool Retrieve();
	bool Store();

	FeeManager *myManager;

	int levelOfDetail;
	int lastLevel;
	int useAI;
	int hitSettings;
	int allowLanding;
	int showAmmoBoard;
	int withHM;
	int useGL;
	int bpp;
	int useHWSurf;
	int fullscreen;
	int showFPS;

	char *filePath;
protected:
	char *dataPath;
};

#endif // !defined(AFX_GAMEOPTIONS_H__29F9945A_AE8B_4417_A348_052A6F578A4A__INCLUDED_)
