// HCAIPlayerSprite.h: interface for the HCAIPlayerSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HCAIPLAYERSPRITE_H__0D41A027_78F7_4CDD_8835_F7D5E152B60A__INCLUDED_)
#define AFX_HCAIPLAYERSPRITE_H__0D41A027_78F7_4CDD_8835_F7D5E152B60A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FeeGlobal.h"
#include "AIPlayerSprite.h"
#include "AIaction.h"
#include "PlayerSprite.h"

class FeeManager;
class AIaction;

class HCAIPlayerSprite : public AIPlayerSprite
{
public:
	HCAIPlayerSprite(int x, int y, int kind, FeeManager *derManager);
	virtual ~HCAIPlayerSprite();

	virtual void Update(float time);
	virtual void Hit(FeeSprite *hitBy);

protected:
	void RemoveAction(AIaction* theAction);
	void AddAction(int theCommand, FeeSprite *target);
	AIaction * FindAction(int type);

	void CheckForThreats();
	int GetTurnDirection(MovingSprite *target, int time);
	int GetDistance(FeeSprite *target);
	int GetTurnDirection(FeeSprite *target);
	int GetTurnDirection(int newX, int newY);
	int GetPriority(AIaction *action);
	int GetTargetAngle(int newX, int newY);
	int GetTargetAngle(MovingSprite *target, int time);

	AIaction *ActionQueue;
	int threatCountdown;
	int actionCount;
};

#endif // !defined(AFX_HCAIPLAYERSPRITE_H__0D41A027_78F7_4CDD_8835_F7D5E152B60A__INCLUDED_)
