// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// MovingSprite.cpp: implementation of the MovingSprite class.
//
//////////////////////////////////////////////////////////////////////

#include <math.h>
#include "FeeManager.h"
#include "MovingSprite.h"
#include "SnoopyGlobals.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MovingSprite::MovingSprite(int x, int y, FeeManager *theManager,bool inFront):FeeSprite(x,y,theManager,inFront)
{	
	angle=0;
}

MovingSprite::~MovingSprite()
{

}

void MovingSprite::ComputeSpeed()
{
	while(angle<0) angle+=16;
	angle=angle%16;
	double winkel=double(angle)/8*PI;

	speedX=cos(winkel)*speed;
	speedY=sin(winkel)*speed;
}

void MovingSprite::Update(float time)
{
	x+=(speedX*time);
	y+=(speedY*time);
}