// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// NoteSprite.cpp: implementation of the NoteSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "MovingSprite.h"
#include "NoteSprite.h"
#include "SnoopyGlobals.h"
#include "sge_misc.h"
#include "FeeManager.h"
#include "PlayerSprite.h"
#include "ShotSprite.h"
#include "FeeImageManager.h"
#include "FeeSound.h"
#include "GameOptions.h"

class FeeManager;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

NoteSprite::NoteSprite(int x, int y, int length, FeeManager *theManager):MovingSprite(x,y,theManager)
{
	int pitch;
	myManager->imageManager->PrecacheFrames(myManager->options->GetDataPath("Grafiken/Note.tga"),5);
	name="Note";
	myKind=NOTE_KIND;
	frame=length;
    if (length != 4) 
	{
		pitch=sge_Random(1,5);
		switch(pitch) // ich bin ein Dichter!
		{
		case 1:
			theSchroederSound1->Play(); // PFUSCH!
			break;
		case 2:
			theSchroederSound2->Play(); // PFUSCH!
			break;
		case 3:
			theSchroederSound3->Play(); // PFUSCH!
			break;
		case 4:
			theSchroederSound4->Play(); // PFUSCH!
			break;
		case 5:
			theSchroederSound5->Play(); // PFUSCH!
			break;
		}
	}
	speedY=-1;
	speedX=0;

	face=myManager->imageManager->GetFrame(myManager->options->GetDataPath("Grafiken/Note.tga"),frame);
	collisionMask=myManager->imageManager->GetFrameMask(myManager->options->GetDataPath("Grafiken/Note.tga"),frame);
}

NoteSprite::~NoteSprite()
{

}

void NoteSprite::Hit(FeeSprite *hitBy)
{
	if ((hitBy->myKind==ARROW_KIND)||(hitBy->myKind==MG_KIND))
	{
		toBeRemoved=true;

		ShotSprite *theShot=(dynamic_cast<ShotSprite*>(hitBy));
		PlayerSprite *owner=theShot->Owner();

		if (owner!=NULL)
		{
			switch(frame)
			{
			case 0:
			case 1:
				owner->AddBonus(1);
				break;
			case 2:
			case 3:
				owner->AddBonus(2);
				break;
			case 4:// pause
				owner->AddBonus(0); // Punkte zurcksetzen
				break;
			}
		}

		// hier Spieler managen 
	}
	if (hitBy->myKind==PLAYER_KIND)
		toBeRemoved=true;
}

void NoteSprite::Update(float time)
{
	if (DoAction(time))
	{
		switch(sge_Random(0,10))
		{
		case 0:
			speedX+=1;
			if (speedX>3) speedX=3;
			break;
		case 1:
			speedX-=1;
			if (speedX<-3) speedX=-3;
			break;
		default:
			break;
		}
	}

	MovingSprite::Update(time);

	if (y<-14) toBeRemoved=true;

	if (x > myManager->maxX) x += -29 -myManager->maxX;
	else if (x < (-29)) x = myManager->maxX +29 + x;
}
