// PAIPlayerSprite.h: interface for the PAIPlayerSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PAIPLAYERSPRITE_H__F31F6D79_6489_4ADD_AF8D_D4F0DE2A6C41__INCLUDED_)
#define AFX_PAIPLAYERSPRITE_H__F31F6D79_6489_4ADD_AF8D_D4F0DE2A6C41__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FeeGlobal.h"
#include "PlayerSprite.h"
#include "AIPlayerSprite.h"

class FeeManager;
class FeeSprite;
class PAIPlayerSprite;

typedef void (*TExternalUpdate)(PAIPlayerSprite *me, FeeManager *myManager);
typedef void (*TExternalHit)(PAIPlayerSprite *me, FeeManager *myManager, FeeSprite *hitBy);
typedef void (*TGetInformation)(char *name, int size, int *version);


class PAIPlayerSprite : public AIPlayerSprite  
{
public:

	PAIPlayerSprite(int x, int y, int kind, FeeManager *derManager, char *library);
	virtual ~PAIPlayerSprite();
	void Update(float time);
	void Hit(FeeSprite *hitBy);
	
	FeeSprite *target1;
	FeeSprite *target2;
	FeeSprite *target3;
	FeeSprite *target4;
	long actionCount1;
	long actionCount2;
	long actionCount3;
	long actionCount4;
	TExternalUpdate ExternalUpdate; // Pointer auf externe Updatefunktion
	TExternalHit ExternalHit;		// Ptr auf ext. Hitfktion
	TGetInformation GetInformation;	// Ptr auf Informationsfktion
protected:
#if defined(WIN32)
	HINSTANCE libraryHandle;
#elif defined(HAVE_LIBDL)
	void *libraryHandle;
#endif
};

#endif // !defined(AFX_PAIPLAYERSPRITE_H__F31F6D79_6489_4ADD_AF8D_D4F0DE2A6C41__INCLUDED_)
