// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// PlayerSprite.cpp: implementation of the PlayerSprite class.
//
//	FIXME: Lots of redundant code.
//  FIXME: The Woodstock code is extremely crappy and b0rken.
//////////////////////////////////////////////////////////////////////

#include <math.h>
#include <stdlib.h>  // fuer _MAX_PATH
#include "FeeGlobal.h"
#include "SnoopyGlobals.h"
#include "PlayerSprite.h"
#include "ShotSprite.h"
#include "FeeManager.h"
#include "SmokeSprite.h"
#include "ExplosionSprite.h"
#include "FeeSound.h"
#include "sge_misc.h"
#include "ParaSprite.h"
#include "CON_console.h"
#include "FeeImageManager.h"
#include "GameOptions.h"

POINT schuss[17]={28,8, 28,20, 23,27, 20,32, 11,28, -1,30, -6,25, -7,18, -12,10, -7,1, -4,-5, 3,-6, 9,-8, 19,-5, 24,0, 25,2, 28,8};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PlayerSprite::PlayerSprite(int x, int y, int kind, FeeManager *derManager):MovingSprite(x,y,derManager)
{
	speedX=LOW_SPEED;
	speedY=0;
	speed=LOW_SPEED;
	myKind=kind;
	angleCountdown=0;
	angleCountdown2 = 0;
	smokeCountdown=-1;
	weapon=MG_KIND;
	deathCountdown = -1;
	bonusPoints=0;
	isDark=false;
	int i;
	
	for (i = 0; i < GESAMTZAHL_WAFFEN; i++)
		shotCountdown[i] = 0;
	//for (i = 0; i < GESAMTZAHL_WAFFEN; i++)
	//	munition[i] = 0;	// Einstellungsdialog notwendig
	munition[ARROW_KIND] = 3;
	fallCountdown=-1;
	bounderState=ELSEWHERE;
	fallDirection=NOT_FALLING;
	hits=0;
	kills=0;
	battles=0;
	reloadCountdown=0;
	name="Snoopy";
}

PlayerSprite::~PlayerSprite()
{
}

void PlayerSprite::Update(float time)
{	
	MovingSprite::Update(time);

	if (DoAction(time))
	{
		DoKeys();
		if (angleCountdown > 0) angleCountdown--;	
		if (angleCountdown2 > 0) angleCountdown2--; 
		if (smokeCountdown > 0) smokeCountdown--;
		for (int i = 0; i < GESAMTZAHL_WAFFEN; i++)
			if (shotCountdown[i] > 0) shotCountdown[i]--;
			
		if (munition[weapon]==0) reloadCountdown--;
		if (hits>0)
			GoDown();
		
		if (!(face))
			InitFace(); // nur beim ersten Mal, fuer den Fall...
		
		if ((smokeCountdown % 3)==0) // jedes dritte Update malt ein Rauchsprite
		{
			new SmokeSprite(x,y,myManager,false);
			if (smokeCountdown==0)
			{
				if (hits>0)
					smokeCountdown = 2; // nur neuen Rauch machen, wenn Spieler getroffen ist
				else
					smokeCountdown = -1; // sonst abschalten
			}
		}
		
		if (deathCountdown > 0) 
		{
			deathCountdown--;
			return; 			// der Spieler bleibt am Boden liegen
		}
		else if (deathCountdown == 0)
			Repair();

		
		if (x > myManager->maxX) x += -29 -myManager->maxX; // an der Seite rausgeflogenen Spieler
		else if (x < (-29)) x = myManager->maxX +29 + x;	// auf die andere Seite bringen
		
		if (y > myManager->maxY)
		{
			if (hits>0) // Woodstock: abgestrzt
			{
				new ExplosionSprite(x,-100,myManager); // soll keinen Schaden machen knnen, nur Sound
				y=myManager->maxY;
				hits=0;
				smokeCountdown = -1;
				fallCountdown = -1;
				fallDirection = NOT_FALLING;
				kills++;
				angle=12;
				deathCountdown=100;
				speed=HIGH_SPEED;
				ComputeSpeed();
				InitFace();
				x=sge_Random(0,myManager->maxX);
			}
		}
		
		if (deathCountdown==-1)
		{
			if (y > (myManager->maxY)) y += -29 -myManager->maxY;  // an der Decke rausgeflogenen Spieler
			else if (y < (-29)) y = myManager->maxY +29 + y; // auf den Boden bringen
		}
	}
	
	return;
}

void PlayerSprite::Repair()
{
	fallDirection = NOT_FALLING; // Hier setzen, denn es muss auch bei einer Notlandung gesetzt werden
	InitFace();
	angleCountdown = 0; 
	angleCountdown2 = 0;
	if (deathCountdown>=0) 
	{
		SetSpeed(STOP_SPEED); // wenn wir vorher tot waren, nicht gleich losfahren
		ComputeSpeed();
	}
	deathCountdown = -1;
	int i;
	
	for (i = 0; i < GESAMTZAHL_WAFFEN; i++)
		shotCountdown[i] = 0;
		/*	for (i = 0; i < GESAMTZAHL_WAFFEN; i++)
		munition[i] = 0;	// Einstellungsdialog notwendig
	*/
	fallCountdown = -1;
	fallDirection = NOT_FALLING;
	hits=0; 
	
	if (y == myManager->maxY)	// Woodstock
	{
		x=sge_Random(0,myManager->maxX); // gegen den Computergegner :-)
		SetSpeed(HIGH_SPEED); // wenn wir vorher tot waren, nicht gleich losfahren
		angle=12;
		ComputeSpeed();
	}
	InitFace();
}

void PlayerSprite::SetSpeed(int newSpeed)
{
	if (deathCountdown > 0) return;
	if (hits > 3) return; // Steuerung ist nicht mehr. Waer ja auch noch schoener.
	if ((hits == 2) && (angleCountdown2 != 1)) return; // Ziemlich stark getroffen. Nur noch jedes zweite Mal reagieren
	speed = newSpeed;
	ComputeSpeed();
}

void PlayerSprite::SetAngle(int angleMod) // TODO: saubermachen
{
	if (deathCountdown > 0) return; // Spieler liegt tot am Boden
	if (speed==STOP_SPEED) return;
	if (angleMod==0) return;
	
	if ((angleMod == INCR_ANGLE)&&(bounderState==ON_GROUND)) return;
	
	if (bounderState==IN_SKY) // dieser dreckige Scheiss will nicht funktionieren.
	{
		if ((angleMod == INCR_ANGLE)&&(angle>=8)&&(angle<=12))
			return;
		else if ((angleMod == DECR_ANGLE)&&((angle>12)||(angle==0)))
			return;
		else if ((angleMod!=PLUNGE_INCR_ANGLE)&&(angleMod!=PLUNGE_DECR_ANGLE)) bounderState = ELSEWHERE;
	}
	
	if ((angleMod == INCR_ANGLE) || (angleMod == DECR_ANGLE))	// Vom Spieler gesteuert
	{
		if ((angleCountdown == 0) && (hits < 3))	// Darf er steuern?
		{
			if ((fallCountdown > 20) && (angleCountdown2 != 1)) // Wenn der Spieler abstrzt (Nr. 101 - Insider, s.u.), darf es nicht ruckeln!
				angleCountdown = 1; // mehr Glueck beim naechsten Mal
			else
			{
				switch (hits)
				{
					// Steuerung je nach eingesteckten Treffern:
				case 0:
				case 1:
					angleCountdown=2;
					break;
				case 2: 
					angleCountdown=4;
					break;
				}
				switch(angleMod)
				{
				case INCR_ANGLE:
					angle+=1;
					break;
				case DECR_ANGLE:
					angle-=1;
					break;
				}
				bounderState=ELSEWHERE; // wenn wir hierher gekommen sind, kann der Spieler _jetzt_ nicht mehr am Boden/Himmel sein.
			}
		}
	}
	else	// Ungewollter Absturz <- Ist das 100. Mal, dass ich erst "Absurz" geschrieben habe
	{		// gibt es eigentlich auch gewollte? :-p
		if (angleCountdown2 == 0)	// Schon wieder dran?
		{
			angleCountdown2 = 2;
			switch (angleMod)
			{
			case PLUNGE_INCR_ANGLE:
				angle+=1;
				break;
			case PLUNGE_DECR_ANGLE:
				angle-=1;
				break;
			}
		}
	}
	ComputeSpeed();
	InitFace();
}

void PlayerSprite::Hit(FeeSprite *hitBy)
{
	if (hitBy->myKind==SKY_KIND)  // gegen Himmel geflogen
	{
		bounderState=IN_SKY;
		SDL_Rect rect=hitBy->GetRect();
		
		y = rect.h;
		if (angle < 12)
			SetAngle(PLUNGE_DECR_ANGLE);
		else
			SetAngle(PLUNGE_INCR_ANGLE);
		return;
	}
	
	if (hitBy->myKind==GROUND_KIND) 
	{
		bounderState=ON_GROUND;
		for (int i = 0; i < GESAMTZAHL_WAFFEN; i++)
			shotCountdown[i] = 1;
		angleCountdown=1;
		if (((angle > 14) || (angle < 2)) && (myManager->options->allowLanding || hits==0))		   // Landewinkel / Optionen - Notlandung aus
		{
			SDL_Rect rect=hitBy->GetRect();
			if (deathCountdown == -1) theLandingSound->Play();
			smokeCountdown=4*3;  // 4 Rauchsprites zeichnen lassen
			angle = 0;			 // Winkel zum landen nicht relativ setzen, also direkt in die Variable und alles anpassen
			ComputeSpeed();
			fallCountdown = -1;
			if (deathCountdown==-1)
				Repair();
			else
				SetSpeed(STOP_SPEED);
			y=myManager->maxY-BODEN;
		}
		else
			if (deathCountdown==(-1))
			{
				KillHim(); // abgestuerzt; der Spieler muss sterben
				return;
			}
			return;
	}
	
	// hits = 0 : Spieler ist nicht getroffen und kann normal steuern
	// hits = 1 : Spieler ist getroffen, schmiert ab, kann aber noch ganz normal gegensteuern
	// hits = 2 : Spieler ist stark getroffen, stuerzt ab, kann nur noch eingeschraenkt gegensteuern
	// hits = 3 : Spieler ist total am Arsch, jetzt hilft nur noch beten
	if ((hitBy->myKind==ARROW_KIND)||(hitBy->myKind == FLYING_PART_KIND)||(hitBy->myKind == HM_KIND))
		hits += 2;
	else if (hitBy->myKind==MG_KIND)
		hits += 1;
	else if ((hitBy->myKind==WOODSTOCK_KIND)&&(hits < 1))
		hits = 1; // Man kann nicht tausendmal hintereinander von Woodstock getroffen werden
	else if ((hitBy->myKind==PUMPKIN_KIND)&&(hits < 2))
		hits = 2; // Man kann nicht tausendmal hintereinander vom Kuerbis getroffen werden
	if (hitBy->myKind==PARA_KIND)
	{
		if ((dynamic_cast<ParaSprite*>(hitBy))->PlayerHitParachute(this)) // gucken, wo wir getroffen wurden
		{
			if (hits < 1)
				hits = 1; // oben
		}
		else
		{
			int weapon=(dynamic_cast<ParaSprite*>(hitBy))->weapon;
			switch (weapon)
			{
			case MG_KIND:
				munition[weapon] = min(munition[weapon]+20,40); 
				break;
			case ARROW_KIND:
				munition[weapon] = min(munition[weapon]+10,25); 
				break;
			case BOMB_KIND:
				munition[weapon] = min(munition[weapon]+2,6);	
				break;
			case HM_KIND:
				munition[weapon] = min(munition[weapon]+3,5);	
				break;
			}
		}
	}
	if (hitBy->myKind==NOTE_KIND)
		if (hits < 1)
			hits = 1;
	if ((hitBy->myKind==EXPLO_KIND)&&(deathCountdown==(-1))) // Explosionen toeten nur, wenn der Spieler lebt...
	{
		KillHim();
		return;
	}
		
	if ((hitBy->myKind==BASEBALL_KIND))
		if (y>=(myManager->maxY-BODEN))
		{
			if (deathCountdown==-1) // Ist der Spieler am Boden und lebt?
			{
				KillHim();
				return;
			}
		}
		else
		{
			hits += 2; // Sagen wir mal, ein Baseball ist so stark wie eine Rakete.
		}


		if (hits>0)
		{
			if (fallCountdown==-1) // wenn Spieler nicht bereits faellt
			{
				theHitSound->Play();
				fallCountdown=0;   // dann faellt er jetzt.
			}
			smokeCountdown=0;
		}

		if (bounderState==ON_GROUND)
			hits=0;
		// Wenn es mal in ferner Zukunft Einstellungen gibt, sind die naechsten Zeilen sinnvoll:
		if ((hits > 1) && (myManager->options->hitSettings==HIT_SETTINGS_STAYS)) hits = 1;
		if ((hits > 0) && (myManager->options->hitSettings==HIT_SETTINGS_NO_CONTROL)) hits = 4;
		return;
}

void PlayerSprite::InitFace()
{
	char filename[_MAX_PATH];
	if (isDark>=2)
		sprintf(filename,myManager->options->GetDataPath("Grafiken/%sDunkel.tga"),name);
	else
		sprintf(filename,myManager->options->GetDataPath("Grafiken/%s.tga"),name);
	
	if(face==NULL)
	{
		myManager->imageManager->PrecacheFrames(filename,17);
	}
	
	frame=angle;
	if (deathCountdown>-1) 
		frame=16;
	
	face=myManager->imageManager->GetFrame(filename,frame);
	collisionMask=myManager->imageManager->GetFrameMask(filename,frame);
}

void PlayerSprite::KillHim()
{
	kills++;
	// meinetwegen hier: wummer!
	speed=STOP_SPEED;
	angle=0;
	new ExplosionSprite(x+14,y+14,myManager);
	if (bounderState!=ON_GROUND)
	{
		x=-29;
	}
	y=myManager->maxY-BODEN;
	deathCountdown = 100;
	smokeCountdown = -1;
	fallCountdown = -1;
	fallDirection = NOT_FALLING;
	hits=0;
	ComputeSpeed();
	InitFace();
}

void PlayerSprite::FireShot()
{
	if (bounderState==ON_GROUND) return; // Spieler ist gelandet.
	if (deathCountdown>0) return;
	
	if (!munition[weapon]&&(weapon!=BOMB_KIND))
	{
		if (munition[ARROW_KIND]) weapon = ARROW_KIND; // Waffenwechsel wenn Munition alle ist
		if (munition[MG_KIND]) weapon = MG_KIND;
	}

	if (shotCountdown[weapon] == 0)
	{
		if ((weapon==ARROW_KIND) && (munition[ARROW_KIND]))
		{
			munition[ARROW_KIND]--;
			shotCountdown[ARROW_KIND]=10;
			theArrowSound->Play();
			if (munition[HM_KIND])
			{
				munition[HM_KIND]--;
				new ShotSprite(x+schuss[angle].x,y+schuss[angle].y,HM_KIND,angle, speed, this, myManager);
			}
			else
				new ShotSprite(x+schuss[angle].x,y+schuss[angle].y,weapon,angle, speed, this, myManager);
		}
		else if ((weapon==MG_KIND) && (munition[MG_KIND]))
		{
			munition[MG_KIND]--;
			if (!(munition[MG_KIND] % 5))
				shotCountdown[MG_KIND]=15;
			else
				shotCountdown[MG_KIND]=3;
			theMGSound->Play();
			new ShotSprite(x+schuss[angle].x,y+schuss[angle].y,weapon,angle, speed, this, myManager, isDark);
		}
		else if ((weapon==BOMB_KIND) && (munition[BOMB_KIND]))
		{
			munition[BOMB_KIND]--;
			shotCountdown[BOMB_KIND]=10;
			//theBombSound->Play();
			new ShotSprite(x+14,y+29,weapon,angle, speed, this, myManager);
		}
	}
	return;
}

SDL_Rect PlayerSprite::GetRect()
{
	SDL_Rect temp={0,0,0,0};
	if (face!=NULL)
	{
		temp.x=x;
		temp.y=y;
		temp.w=29;
		temp.h=29;
	}
	return temp;
}

void PlayerSprite::ChooseWeapon(int waffe)
{
	if ( !((waffe < 0) || (waffe >= GESAMTZAHL_WAFFEN)) )
		weapon=waffe;
}

void PlayerSprite::GoDown() 
{
	if (fallDirection==NOT_FALLING)
	{
		if ((angle>=12)||(angle<4))
			fallDirection=DIR_CLOCKWISE;
		else
			fallDirection=DIR_COUNTERCLOCKWISE;
	}
	if ((fallCountdown < 20) && (angle > 12) && (angle < 14))
		fallCountdown = 20; // Es sieht dumm aus, wenn der Spieler ganz nach oben sieht, aber nach unten faellt...
	if (fallCountdown >= 20)
	{
		if (fallDirection==DIR_CLOCKWISE)
			SetAngle(PLUNGE_INCR_ANGLE);
		else
			SetAngle(PLUNGE_DECR_ANGLE);
	}
	fallCountdown++;
	if (fallCountdown == 200) 
	{
		hits++; // Steuerung verschlechtert sich mit der Zeit, damit man sich mit dem Notlanden beeilen muss.
		// Wenn es mal in ferner Zukunft Einstellungen gibt, sind die naechsten Zeilen sinnvoll:
		// if ((hits > 1) && (Einstellung: Steuerung kann nicht schlechter werden)) hits = 1;
		// if ((hits > 0) && (Einstellung: Steuerung ist immer sofort ganz weg)) hits = 3;
	}
	if (fallCountdown == 400)
	{
		// Wenn man es so lange geschafft hat, bekommt man nochmal die Moeglichkeit, sich andersherum zu drehen.
		fallCountdown = 0;
		fallDirection = NOT_FALLING;
	}
	ComputeSpeed();
}

void PlayerSprite::NewLevel()
{
	x=sge_Random(0,myManager->maxX);
	
	y=100+(10*sge_Random(2,6)); 
	
	speedX=LOW_SPEED;
	speedY=0;
	speed=LOW_SPEED;
	angleCountdown=0;	
	angleCountdown2 = 0;
	smokeCountdown=-1;
	weapon=MG_KIND;
	deathCountdown = -1;
	int i;
	for (i = 0; i < GESAMTZAHL_WAFFEN; i++)
		munition[i] = 0;	// Einstellungsdialog notwendig
	for (i = 0; i < GESAMTZAHL_WAFFEN; i++)
		shotCountdown[i] = 0;	// Einstellungsdialog notwendig
	reloadCountdown=0;
	fallCountdown=-1;
	bounderState=ELSEWHERE;
	fallDirection=NOT_FALLING;
	hits=0;
	angle=0;
	kills=0;
	
	face=NULL;
	InitFace();
}

void PlayerSprite::DropBomb()
{
	int oldWeapon=weapon;
	weapon=BOMB_KIND;
	FireShot();
	weapon=oldWeapon;
}

void PlayerSprite::AddBonus(int i)
{
	if (i==0)
		bonusPoints=0;
	bonusPoints+=i;
	if ((bonusPoints>=4)&&(kills>0)) 
	{
		kills--;
		bonusPoints=0;
	}
}

int PlayerSprite::GetAngle()
{
	return angle;
}

int PlayerSprite::GetAmmo(int kind)
{
	return munition[kind];
}

int PlayerSprite::GetHits()
{
	return hits;
}

bool PlayerSprite::GetDead()
{
	if (hits>=4) return true;
	return max(deathCountdown,0);
}

void PlayerSprite::Reload(int kind)
{
	if (reloadCountdown<=0)
	{
		switch (kind)
		{
		case MG_KIND:
			munition[kind]+=5;
			munition[kind]=min(munition[kind],10);
			reloadCountdown=80;
			break;
		case ARROW_KIND:
			munition[kind]+=3;
			munition[kind]=min(munition[kind],14);
			reloadCountdown=100;
			break;
		default:
			munition[kind]+=5;
			munition[kind]=min(munition[kind],20);
			reloadCountdown=80;
			break;
		}
	}
}

bool PlayerSprite::ShowAmmo()
{
	if (myManager->options->showAmmoBoard==AMMO_BOARD_NONE)
		return false;
	return true;
}

bool PlayerSprite::IsAI()
{
	return false;
}

int PlayerSprite::HasWeapons()
{
	if (munition[ARROW_KIND]||munition[MG_KIND]) return true;
	return false;
}

void PlayerSprite::ComputeSpeed()
{
	MovingSprite::ComputeSpeed();
	if (hits>0)
	{
		speedY+=2;
		if ((fallCountdown < 20) && (speedY < 0)) speedY=1; // In der Sinkphase kann man nicht nach oben fliegen. PP.
	}
	if (deathCountdown>0)
	{
		speedX=0;
		speedY=0;
	}
}

void PlayerSprite::DoKeys()
{
	if (myManager->keystateValid)
	{
		if (myManager->keystate[myKeys.highspeed])
		{
			SetSpeed(HIGH_SPEED);
		}
		if (myManager->keystate[myKeys.lowspeed])
		{
			SetSpeed(LOW_SPEED);
		}
		if (myManager->keystate[myKeys.incrangle])
		{
			SetAngle(INCR_ANGLE);
		}
		if (myManager->keystate[myKeys.decrangle])
		{
			SetAngle(DECR_ANGLE);
		}
		if (myManager->keystate[myKeys.fire])
		{
			FireShot();
		}
		if (myManager->keystate[myKeys.mg])
		{
			ChooseWeapon(MG_KIND);
		}
		if (myManager->keystate[myKeys.arrow])
		{
			ChooseWeapon(ARROW_KIND);
		}
		if (myManager->keystate[myKeys.bomb])
		{
			DropBomb();
		}
	}
}


