// PlayerSprite.h: interface for the PlayerSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLAYERSPRITE_H__B2856A3D_780D_4F67_AA98_66111B5735CA__INCLUDED_)
#define AFX_PLAYERSPRITE_H__B2856A3D_780D_4F67_AA98_66111B5735CA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "MovingSprite.h"
#include "SnoopyGlobals.h"
#include "PlayerKeys.h"

#define NOT_FALLING 0
#define DIR_CLOCKWISE 1
#define DIR_COUNTERCLOCKWISE 2
#define ELSEWHERE 0
#define ON_GROUND 1
#define IN_SKY 2

class PlayerSprite : public MovingSprite  
{
public:
	int HasWeapons();
	virtual void Reload(int kind);
	virtual bool GetDead();
	virtual int GetHits();
	virtual int GetAmmo(int kind);
	virtual int GetAngle();
	virtual void AddBonus(int i);
	virtual void DropBomb();
	virtual void NewLevel();
	virtual bool ShowAmmo();
	int battles;
	int kills;
	PlayerSprite(int x, int y, int kind, FeeManager *derManager);
	virtual ~PlayerSprite();
	virtual void ChooseWeapon(int waffe);		// waehlt die Waffe aus
	virtual void FireShot();	// schiet und liefert den Schuss zurueck. Schuss wird automatisch einsortiert, Rueckgabewert kann ignoriert werden
	void KillHim();			// explodiert Spieler, z.B. nach Absturz
	virtual void SetAngle(int angleMod); // _modifiziert_ Winkel, mit DECR_ANGLE oder INCR_ANGLE
	virtual void SetSpeed(int speed); // _setzt_ Geschwindigkeit, HIGH_SPEED, LOW_SPEED, STOP_SPEED
	virtual void InitFace();  // setzt Face entsprechend dem Winkel
	virtual void Hit(FeeSprite *hitBy); // wird aufgerufen bei Treffer
	virtual void Update(float time); // dito bei Update
	virtual bool IsAI();
	SDL_Rect GetRect(); // gibt Bounding Rect zurueck
	void Repair(); // setzt den Zustand des Spielers zurueck
	int bounderState;	// befindet sich der Spieler an einem Bounder?
	int isDark;

	Keys myKeys;
protected:
	void DoKeys();
	void ComputeSpeed();
	int fallDirection;
	void GoDown();   // bewegt Spieler analog zum Schaden
	int weapon;      // aktuelle Waffe, ARROW_KIND oder MG_KIND
	int angleCountdown; // Countdowns fuer Dinge, die nur jeden x-ten Zug gemacht werden
	int angleCountdown2;// fuer das automatische Drehen beim Abstuerzen
	int smokeCountdown; // -1 bedeutet meist, dass nicht rueckgezaehlt wird.
	int deathCountdown; // "
	int shotCountdown[GESAMTZAHL_WAFFEN];// fr Pfeile und MG und spter auch Bomben
	int munition[GESAMTZAHL_WAFFEN];// fr Pfeile und MG und spter auch Bomben
	int fallCountdown;  // "
	int reloadCountdown;// frs automatische Nachladen
	int hits;           // Anzahl der bisher eingesteckten Treffer(punkte).
	int bonusPoints;	// "Bonuspunkte"; bei vier Punkten wird ein Hit abgezogen.
};

#endif // !defined(AFX_PLAYERSPRITE_H__B2856A3D_780D_4F67_AA98_66111B5735CA__INCLUDED_)
