// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// SmokeSprite.cpp: implementation of the SmokeSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "FeeSprite.h"
#include "SmokeSprite.h"
#include "FeeGlobal.h"
#include "SnoopyGlobals.h"
#include "FeeImageManager.h"
#include "FeeManager.h"
#include "GameOptions.h"

#define SMOKE_IMAGE myManager->options->GetDataPath("Grafiken/SmokePuff.tga")

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SmokeSprite::SmokeSprite(int x, int y, FeeManager *derManager, bool inFront):FeeSprite(x,y, derManager, inFront)
{
	age = 0;
	myKind=SMOKE_KIND; // nur fr den Fall...
	name="Smoke";
	canCollide=false;
}

SmokeSprite::~SmokeSprite()
{
}

void SmokeSprite::Hit(FeeSprite *hitBy)
{
}

void SmokeSprite::Update(float time)
{
	if(!face)
	{
		myManager->imageManager->PrecacheFrames(SMOKE_IMAGE,5);
		face=myManager->imageManager->GetFrame(SMOKE_IMAGE,frame);
		collisionMask=myManager->imageManager->GetFrameMask(SMOKE_IMAGE,frame);
	}

	if (DoAction(time))
	{
		age++;
		switch (age)
		{
			case 4: 
				frame=1;
				face=myManager->imageManager->GetFrame(SMOKE_IMAGE,frame);
				collisionMask=myManager->imageManager->GetFrameMask(SMOKE_IMAGE,frame);
				break;
			case 7: 
				frame=2;
				face=myManager->imageManager->GetFrame(SMOKE_IMAGE,frame);
				collisionMask=myManager->imageManager->GetFrameMask(SMOKE_IMAGE,frame);
				break;
			case 10: 
				frame=3;
				face=myManager->imageManager->GetFrame(SMOKE_IMAGE,frame);
				collisionMask=myManager->imageManager->GetFrameMask(SMOKE_IMAGE,frame);
				break;
			case 13: 
				frame=4;
				face=myManager->imageManager->GetFrame(SMOKE_IMAGE,frame);
				collisionMask=myManager->imageManager->GetFrameMask(SMOKE_IMAGE,frame);
				break;
		}
		if (age > 15) toBeRemoved=true;
	}
	if (myManager->options->levelOfDetail>=2)
		alpha=128-((112*age)/16);
	else if (myManager->options->levelOfDetail==1)
		alpha=128;
	else
		alpha=SDL_ALPHA_OPAQUE;

	if (myManager->options->bpp==8)
		alpha=SDL_ALPHA_OPAQUE;
}