// StatusSprite.h: interface for the StatusSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATUSSPRITE_H__588D0AAA_36D6_4148_B7F2_CB71775CF681__INCLUDED_)
#define AFX_STATUSSPRITE_H__588D0AAA_36D6_4148_B7F2_CB71775CF681__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FeeSprite.h"
#include "SDL.h"

class FeeManager;
class PlayerSprite;

class StatusSprite : public FeeSprite  
{
public:
	StatusSprite(PlayerSprite *Spieler1,PlayerSprite *Spieler2, FeeManager *theManager);
	virtual ~StatusSprite();
	char *GetLevelName();
	void SetLevel(int level);
	virtual void DrawTo(SDL_Surface *targetSurface);
	virtual void Hit(FeeSprite *hitBy);
	virtual void Update(float time);
	void NewLevel();
	void ClearLevel();
	int GetLevel();
protected:
	int level;
	char *levelName;
	PlayerSprite *Spieler1;	
	PlayerSprite *Spieler2;
	SDL_Surface *numbers;
	SDL_Surface *matrixmap;
	SDL_Surface *ammoBoard;
	int matrix_x;
	int matrix_y;
	void inline DrawNum(int x,int num,SDL_Surface *target);
	void inline DrawAmmoBoard(PlayerSprite* Player,int x, int y, SDL_Surface *target);
	void inline DrawMatrix(int x, int y,int character,bool light);
private:
	bool renderedClouds;
};

#endif // !defined(AFX_STATUSSPRITE_H__588D0AAA_36D6_4148_B7F2_CB71775CF681__INCLUDED_)
