// This program is open source. It is placed under the Q public license.
// Copyright 2000/2001 by J. Fortmann/T.Wiesehfer.

// WoodstockSprite.cpp: implementation of the WoodstockSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "FeeSprite.h"
#include "FeeManager.h"
#include "MovingSprite.h"
#include "WoodstockSprite.h"
#include "sge_misc.h"
#include "SnoopyGlobals.h"
#include "SDL.h"
#include "FeeImageManager.h"
#include "GameOptions.h"


#define WOODSTOCK_IMAGE myManager->options->GetDataPath("Grafiken/Woodstock.tga")
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

WoodstockSprite::WoodstockSprite(FeeManager *theManager):MovingSprite(0,0, theManager)
{
	name="Woodstock";
	this->x=sge_Random(0,myManager->maxX);
	this->y=sge_Random(0,myManager->maxY);
	speed=4;
	myManager->imageManager->PrecacheFrames(WOODSTOCK_IMAGE,16);
	myKind=WOODSTOCK_KIND;
	ComputeSpeed();
	face=myManager->imageManager->GetFrame(WOODSTOCK_IMAGE,angle);
	collisionMask=myManager->imageManager->GetFrameMask(WOODSTOCK_IMAGE,angle);
}

WoodstockSprite::~WoodstockSprite()
{

}


void WoodstockSprite::Update(float time)
{
	if (DoAction(time))
	{
		int i=sge_Random(0,6);

		if(i==0)				// bischen zuflliges schunkeln
		{
			angle+=1;
			ComputeSpeed();
			face=myManager->imageManager->GetFrame(WOODSTOCK_IMAGE,angle);
			collisionMask=myManager->imageManager->GetFrameMask(WOODSTOCK_IMAGE,angle);
		}
		else if(i==1)
		{
			angle-=1;
			ComputeSpeed();
			face=myManager->imageManager->GetFrame(WOODSTOCK_IMAGE,angle);
			collisionMask=myManager->imageManager->GetFrameMask(WOODSTOCK_IMAGE,angle);
		}
	}
		
	MovingSprite::Update(time);

	if (x > myManager->maxX) x += -29 -myManager->maxX; // an der Seite rausgeflogenen Vogel
	else if (x < (-29)) x = myManager->maxX +29 + x;    // auf die andere Seite bringen

	if (y > myManager->maxY) y += -29 -myManager->maxY; // an der Decke rausgeflogenen Vogel
	else if (y < (-29)) y = myManager->maxY +29 + y;    // auf den Boden bringen

	// der Boden muss nicht behandelt werden. :-)))


	frame = angle;
}

void WoodstockSprite::Hit(FeeSprite *hitBy)
{
}