#ifdef MACOSX
#include "carbonspecific.h"
#include <Carbon/Carbon.h>
#include "FeeManager.h"
#include "GameOptions.h"


extern FeeManager *theSpriteManager;
WindowRef optionsWindow;
#define controlID 129
#define ammunitionBoardID 130
#define lodSliderID 131
#define useGLID 132
#define useAIID 133
#define allowLandingID 134
#define homingMissileID 135
#define kSettingsSignature 'sett'

ControlHandle 	controlSettings,
                ammunitionBoardSettings,
                lodSlider,
                useGLSwitch,
                allowLandingSwitch,
                homingMissileSwitch,
                useAISwitch;

pascal OSStatus DlgProcOptions(EventHandlerCallRef handlerRef, 
                            EventRef event, void *userData);

pascal OSStatus SheetHandler(EventHandlerCallRef handlerRef, 
                            EventRef event, void *userData);

int ShowOptions()
{
        IBNibRef nibRef;
        EventTypeSpec theSpec = {kEventClassCommand, kEventProcessCommand};
        CreateNibReference(CFSTR("MacOSX"), &nibRef);
        CreateWindowFromNib(nibRef, CFSTR("PreferencesWindow"), &optionsWindow);
        DisposeNibReference(nibRef);
        InstallWindowEventHandler (optionsWindow,NewEventHandlerUPP(DlgProcOptions),
            1, &theSpec, (void*)optionsWindow, NULL);
        //Controls holen:
        ControlID controlControlID = {kSettingsSignature, controlID};
        ControlID ammunitionBoardControlID = {kSettingsSignature, ammunitionBoardID};
        ControlID lodSliderControlID = {kSettingsSignature, lodSliderID};
        ControlID useGLControlID = {kSettingsSignature, useGLID};
        ControlID useAIControlID = {kSettingsSignature, useAIID};
        ControlID allowLandingControlID = {kSettingsSignature, allowLandingID};
        ControlID homingMissileControlID = {kSettingsSignature, homingMissileID};
        
        GetControlByID(optionsWindow, &controlControlID, &controlSettings);
        GetControlByID(optionsWindow, &ammunitionBoardControlID, &ammunitionBoardSettings);
        GetControlByID(optionsWindow, &lodSliderControlID, &lodSlider);
        GetControlByID(optionsWindow, &useGLControlID, &useGLSwitch);
        GetControlByID(optionsWindow, &useAIControlID, &useAISwitch);
        GetControlByID(optionsWindow, &allowLandingControlID, &allowLandingSwitch);
        GetControlByID(optionsWindow, &homingMissileControlID, &homingMissileSwitch);
        //Werte setzen:
        switch (theSpriteManager->options->hitSettings)
        {
            case HIT_SETTINGS_GETS_WORSE:
            SetControlValue(controlSettings, 1);
            break;
            case HIT_SETTINGS_STAYS:
            SetControlValue(controlSettings, 3);
            break;
            case HIT_SETTINGS_NO_CONTROL:
            SetControlValue(controlSettings, 2);
            break;
        }
        
        switch (theSpriteManager->options->showAmmoBoard)
        {
            case AMMO_BOARD_ALL:
            SetControlValue(ammunitionBoardSettings, 1);
            break;
            case AMMO_BOARD_NO_AI:
            SetControlValue(ammunitionBoardSettings, 2);
            break;
            case AMMO_BOARD_NONE:
            SetControlValue(ammunitionBoardSettings, 3);
            break;
        }

        SetControlValue(lodSlider, theSpriteManager->options->levelOfDetail);
        SetControlValue(useGLSwitch, theSpriteManager->options->useGL);
        SetControlValue(useAISwitch, theSpriteManager->options->useAI);
        SetControlValue(allowLandingSwitch, theSpriteManager->options->allowLanding);
        SetControlValue(homingMissileSwitch, theSpriteManager->options->withHM);
        #ifndef HAVE_GL_H
            DeactivateControl(useGLSwitch);
        #endif
        ShowWindow(optionsWindow);
        return 0;
}

pascal OSStatus DlgProcOptions(EventHandlerCallRef handlerRef, 
                            EventRef event, void *userData)
{
        OSStatus result = eventNotHandledErr;
        HICommand command;
	int useGL;
        GetEventParameter (event, kEventParamDirectObject, typeHICommand, NULL,
                            sizeof(HICommand), NULL, &command);
	switch (command.commandID)
	{
            case 'ok  ':
            {
                theSpriteManager->options->allowLanding = GetControlValue(allowLandingSwitch);			theSpriteManager->options->useAI = GetControlValue(useAISwitch);			theSpriteManager->options->withHM = GetControlValue(homingMissileSwitch);
                useGL = GetControlValue(useGLSwitch);
		// Kontroll-Verschlechterungen
                switch (GetControlValue(controlSettings))
                {
                    case 1:
                    theSpriteManager->options->hitSettings=HIT_SETTINGS_GETS_WORSE;
                    break;
                    case 2:
                    theSpriteManager->options->hitSettings=HIT_SETTINGS_NO_CONTROL;
                    break;
                    case 3:
                    theSpriteManager->options->hitSettings=HIT_SETTINGS_STAYS;
                    break;
                 }
                // Munitionsanzeige
                switch (GetControlValue(ammunitionBoardSettings))
                {
                    case 1:
                    theSpriteManager->options->showAmmoBoard=AMMO_BOARD_ALL;
                    break;
                    case 2:
                    theSpriteManager->options->showAmmoBoard=AMMO_BOARD_NO_AI;
                    break;
                    case 3:
                    theSpriteManager->options->showAmmoBoard=AMMO_BOARD_NONE;
                    break;
                }
                theSpriteManager->options->levelOfDetail = GetControlValue(lodSlider);
                theSpriteManager->options->OptionsChanged();
                if (useGL!=theSpriteManager->options->useGL)
                {
                    IBNibRef nibRef;
                    WindowRef theSheet;
                    EventTypeSpec theSpec = {kEventClassCommand, kEventProcessCommand};
                    CreateNibReference(CFSTR("MacOSX"), &nibRef);
                    CreateWindowFromNib(nibRef, CFSTR("OpenGLSheet"), &theSheet);
                    DisposeNibReference(nibRef);
                    InstallWindowEventHandler (theSheet, NewEventHandlerUPP(SheetHandler),
            1, &theSpec, (void*)theSheet, NULL);
                    ShowSheetWindow(theSheet, (WindowRef)userData);
                    result = noErr;
                    break;
                                    }
		DisposeWindow(optionsWindow);
		result = noErr;
            }
            break;
            case 'not!':
            {
                DisposeWindow(optionsWindow);
                result = noErr;
            }
            break;
        }
	return result;
}

pascal OSStatus SheetHandler(EventHandlerCallRef handlerRef, 
                            EventRef event, void *userData)
{
        OSStatus result = eventNotHandledErr;
        HICommand command;
        GetEventParameter (event, kEventParamDirectObject, typeHICommand, NULL,
                            sizeof(HICommand), NULL, &command);
	switch (command.commandID)
	{
            case 'ok  ':
            {
                theSpriteManager->options->useGL=!(theSpriteManager->options->useGL);
                theSpriteManager->options->Store();
                SDL_Event quit;
                quit.type=SDL_QUIT;
                SDL_PushEvent(&quit);
                HideSheetWindow((WindowRef)userData);
                DisposeWindow((WindowRef)userData);
                DisposeWindow(optionsWindow);
		result = noErr;
            }
            break;
            case 'not!':
            {
                HideSheetWindow((WindowRef)userData);
                DisposeWindow((WindowRef)userData);
                SetControlValue(useGLSwitch, theSpriteManager->options->useGL);
                result = noErr;
            }
            break;
        }
	return result;
}

#endif