/*
*	SDL Graphics Extension
*	Collision routines (header)
*
*	Started 000625
*
*	License: LGPL v2+ (see the file LICENSE)
*	(c)1999-2001 Anders Lindstrm
*/

/*********************************************************************
 *  This library is free software; you can redistribute it and/or    *
 *  modify it under the terms of the GNU Library General Public      *
 *  License as published by the Free Software Foundation; either     *
 *  version 2 of the License, or (at your option) any later version. *
 *********************************************************************/

#ifndef sge_collision_H
#define sge_collision_H

#include <SDL.h>
#include "sge_internal.h"

/* The collision struct */
typedef struct
{
	Uint8 *map;
	Uint16 w,h;
	Uint8 frame;
} sge_cdata;

#ifdef _SGE_C
extern "C" {
#endif
sge_cdata *sge_make_cmap(SDL_Surface *img);
int sge_bbcheck(sge_cdata *cd1,Sint16 x1,Sint16 y1, sge_cdata *cd2,Sint16 x2,Sint16 y2);
int _sge_bbcheck(Sint16 x1,Sint16 y1,Sint16 w1,Sint16 h1, Sint16 x2,Sint16 y2,Sint16 w2,Sint16 h2);
int _sge_cmcheck(sge_cdata *cd1,Sint16 x1,Sint16 y1, sge_cdata *cd2,Sint16 x2,Sint16 y2);
int sge_cmcheck(sge_cdata *cd1,Sint16 x1,Sint16 y1, sge_cdata *cd2,Sint16 x2,Sint16 y2);
Sint16 sge_get_cx(void);
Sint16 sge_get_cy(void);
void sge_destroy_cmap(sge_cdata *cd);
void sge_unset_cdata(sge_cdata *cd, Sint16 x, Sint16 y, Sint16 w, Sint16 h);
void sge_set_cdata(sge_cdata *cd, Sint16 x, Sint16 y, Sint16 w, Sint16 h);
inline Uint32 sge_GetPixel(SDL_Surface *surface, Sint16 x, Sint16 y);
#ifdef _SGE_C
}
#endif

#endif /* sge_collision_H */
