#ifdef WIN32
#include "winspecific.h"

#include "reswin.h"

#include "FeeManager.h"
#include "GameOptions.h"

#include <windows.h>
#include <commctrl.h>

extern FeeManager *theSpriteManager;

int doQuit;

BOOL CALLBACK DlgProcOptions(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);

int ShowOptions()
{
	//ShowWindow(CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_OPTIONS), NULL, DlgProcOptions), SW_SHOW);
	doQuit=0;
	//DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_OPTIONS), NULL, DlgProcOptions);
	return doQuit;
}

BOOL CALLBACK DlgProcOptions(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int useGL;

	switch (msg)
	{
	case WM_INITDIALOG:
		{
			SendDlgItemMessage(hwndDlg, IDC_LANDING, BM_SETCHECK, (theSpriteManager->options->allowLanding) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_USEAI, BM_SETCHECK, (theSpriteManager->options->useAI) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_WITHHM, BM_SETCHECK, (theSpriteManager->options->withHM) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_USEGL, BM_SETCHECK, (theSpriteManager->options->useGL) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_USEHW, BM_SETCHECK, (theSpriteManager->options->useHWSurf) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_FULLSCREEN, BM_SETCHECK, (theSpriteManager->options->fullscreen) ? BST_CHECKED : BST_UNCHECKED, 0);

			// Kontroll-Verschlechterungen
			SendDlgItemMessage(hwndDlg, IDC_CONTROL1, BM_SETCHECK, (theSpriteManager->options->hitSettings==HIT_SETTINGS_GETS_WORSE) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_CONTROL2, BM_SETCHECK, (theSpriteManager->options->hitSettings==HIT_SETTINGS_STAYS) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_CONTROL3, BM_SETCHECK, (theSpriteManager->options->hitSettings==HIT_SETTINGS_NO_CONTROL) ? BST_CHECKED : BST_UNCHECKED, 0);

			// Munitionsanzeige
			SendDlgItemMessage(hwndDlg, IDC_AMMOBOARD1, BM_SETCHECK, (theSpriteManager->options->showAmmoBoard==AMMO_BOARD_ALL) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_AMMOBOARD2, BM_SETCHECK, (theSpriteManager->options->showAmmoBoard==AMMO_BOARD_NO_AI) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_AMMOBOARD3, BM_SETCHECK, (theSpriteManager->options->showAmmoBoard==AMMO_BOARD_NONE) ? BST_CHECKED : BST_UNCHECKED, 0);

			SendDlgItemMessage(hwndDlg, IDC_16BPP, BM_SETCHECK, (theSpriteManager->options->bpp==16) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_32BPP, BM_SETCHECK, (theSpriteManager->options->bpp==32) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hwndDlg, IDC_0BPP, BM_SETCHECK, (theSpriteManager->options->bpp==0) ? BST_CHECKED : BST_UNCHECKED, 0);
			
			SendDlgItemMessage(hwndDlg, IDC_DETAIL, TBM_SETRANGE, (WPARAM) TRUE, (LPARAM) MAKELONG(0, 4));
			SendDlgItemMessage(hwndDlg, IDC_DETAIL, TBM_SETPOS, (WPARAM) TRUE, (LPARAM) theSpriteManager->options->levelOfDetail);

#ifndef HAVE_GL_H
			EnableWindow(GetDlgItem(hwndDlg,IDC_USEGL), false);			
#endif
			return TRUE;
		}
	case WM_COMMAND:
		switch ((int)wParam)
		{
		case IDOK:
			theSpriteManager->options->allowLanding = SendDlgItemMessage(hwndDlg, IDC_LANDING, BM_GETCHECK, 0, 0);
			theSpriteManager->options->useAI = SendDlgItemMessage(hwndDlg, IDC_USEAI, BM_GETCHECK, 0, 0);
			theSpriteManager->options->withHM = SendDlgItemMessage(hwndDlg, IDC_WITHHM, BM_GETCHECK, 0, 0);

			theSpriteManager->options->fullscreen = SendDlgItemMessage(hwndDlg, IDC_FULLSCREEN, BM_GETCHECK, 0, 0);
			theSpriteManager->options->useHWSurf = SendDlgItemMessage(hwndDlg, IDC_USEHW, BM_GETCHECK, 0, 0);
			useGL = SendDlgItemMessage(hwndDlg, IDC_USEGL, BM_GETCHECK, 0, 0);

			// Kontroll-Verschlechterungen
			if (SendDlgItemMessage(hwndDlg, IDC_CONTROL1, BM_GETCHECK, 0, 0))
				theSpriteManager->options->hitSettings=HIT_SETTINGS_GETS_WORSE;
			if (SendDlgItemMessage(hwndDlg, IDC_CONTROL2, BM_GETCHECK, 0, 0))
				theSpriteManager->options->hitSettings=HIT_SETTINGS_STAYS;
			if (SendDlgItemMessage(hwndDlg, IDC_CONTROL3, BM_GETCHECK, 0, 0))
				theSpriteManager->options->hitSettings=HIT_SETTINGS_NO_CONTROL;

			// Munitionsanzeige
			if (SendDlgItemMessage(hwndDlg, IDC_AMMOBOARD1, BM_GETCHECK, 0, 0))
				theSpriteManager->options->showAmmoBoard=AMMO_BOARD_ALL;
			if (SendDlgItemMessage(hwndDlg, IDC_AMMOBOARD2, BM_GETCHECK, 0, 0))
				theSpriteManager->options->showAmmoBoard=AMMO_BOARD_NO_AI;
			if (SendDlgItemMessage(hwndDlg, IDC_AMMOBOARD3, BM_GETCHECK, 0, 0))
				theSpriteManager->options->showAmmoBoard=AMMO_BOARD_NONE;

			// Farbtiefe
			if (SendDlgItemMessage(hwndDlg, IDC_16BPP, BM_GETCHECK, 0, 0))
				theSpriteManager->options->bpp=16;
			if (SendDlgItemMessage(hwndDlg, IDC_32BPP, BM_GETCHECK, 0, 0))
				theSpriteManager->options->bpp=32;
			if (SendDlgItemMessage(hwndDlg, IDC_0BPP, BM_GETCHECK, 0, 0))
				theSpriteManager->options->bpp=0;


			theSpriteManager->options->levelOfDetail = SendDlgItemMessage(hwndDlg, IDC_DETAIL, TBM_GETPOS, 0, 0);

			theSpriteManager->options->OptionsChanged();
			
			if (useGL!=theSpriteManager->options->useGL)
				if (MessageBox(NULL,"OpenGL cannot be toggled without exiting.\nYou will then have to restart manually.\nIf do not choose to exit, your change will be reverted.\nDo you want to exit now?","OpenGL toggled",MB_YESNO)==IDYES)
				{
					theSpriteManager->options->useGL=useGL;
					theSpriteManager->options->Store();
					SDL_Event quit;
					quit.type=SDL_QUIT;
					SDL_PushEvent(&quit);
					doQuit=1;
				}

			DestroyWindow(hwndDlg);
			return TRUE;
		case IDCANCEL:
			DestroyWindow(hwndDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}
#endif // WIN32